function onKeyHandler() {
	this.callback(this.id, "ONKEY");
}





function getIconClassInternal(currentApplication, nm) {
	var activeFormName;
	var windowName=currentApplication.currentWindow.A4GL_name;
	if (currentApplication.currentWindow && currentApplication.currentWindow.activeForm) { activeFormName=currentApplication.currentWindow.activeForm.A4GL_name; }

	return getIconClass(nm,activeFormName,windowName);
}


function getKeyNameInternal(currentApplication, s) {
var rval;
var activeFormName;
var windowName=currentApplication.currentWindow.A4GL_name;
if (currentApplication.currentWindow && currentApplication.currentWindow.activeForm) { activeFormName=currentApplication.currentWindow.activeForm.A4GL_name; }
rval=getKeyName(s, activeFormName,windowName);
if (rval) return rval;

switch (s) {
case "1": return "^A";
case "2": return "^B";
case "3": return "^C";
case "4": return "^D";
case "5": return "^E";
case "6": return "^F";
case "7": return "^G";
case "8": return "^H";
case "9": return "^I";
case "10": return "^J";
case "11": return "^K";
case "12": return "^L";
case "13": return "^M";
case "14": return "^N";
case "15": return "^O";
case "16": return "^P";
case "17": return "^Q";
case "18": return "^R";
case "19": return "^S";
case "20": return "^T";
case "21": return "^U";
case "22": return "^V";
case "23": return "^W";
case "24": return "^X";
case "25": return "^Y";
case "26": return "^Z";

		case "2000": return "DOWN";
		case "2001": return "UP";
		case "2002": return "LEFT";
		case "2003": return "RIGHT";

		case "3000": return "F1";
		case "3001": return "F2";
		case "3002": return "F3";
		case "3003": return "F4";
		case "3004": return "F5";
		case "3005": return "F6";
		case "3006": return "F7";
		case "3007": return "F8";
		case "3008": return "F9";
		case "3009": return "F10";
		case "3010": return "F11";
		case "3011": return "F12";
}
return s;
}


function getKeyDescriptionInternal(currentApplication, s) {
var activeFormName;
var windowName=currentApplication.currentWindow.A4GL_name;
if (currentApplication.currentWindow && currentApplication.currentWindow.activeForm) { activeFormName=currentApplication.currentWindow.activeForm.A4GL_name; }
rval=getKeyDescription(s, activeFormName,windowName);


if (rval) return rval;

console.log("CHECKING key : " + s);

switch (s) {
case "1": return "^A";
case "2": return "^B";
case "3": return "^C";
case "4": return "^D";
case "5": return "^E";
case "6": return "^F";
case "7": return "^G";
case "8": return "^H";
case "9": return "^I";
case "10": return "^J";
case "11": return "^K";
case "12": return "^L";
case "13": return "^M";
case "14": return "^N";
case "15": return "^O";
case "16": return "^P";
case "17": return "^Q";
case "18": return "^R";
case "19": return "^S";
case "20": return "^T";
case "21": return "^U";
case "22": return "^V";
case "23": return "^W";
case "24": return "^X";
case "25": return "^Y";
case "26": return "^Z";

		case "2000": return "DOWN";
		case "2001": return "UP";
		case "2002": return "LEFT";
		case "2003": return "RIGHT";
		case "2016": return "ACCEPT";
		case "2011": return "INTERRUPT";

		case "3000": return "F1";
		case "3001": return "F2";
		case "3002": return "F3";
		case "3003": return "F4";
		case "3004": return "F5";
		case "3005": return "F6";
		case "3006": return "F7";
		case "3007": return "F8";
		case "3008": return "F9";
		case "3009": return "F10";
		case "3010": return "F11";
		case "3011": return "F12";
}
return s;
}


function generateToolbar(context, events, callback) {
    var pan;

    // items should be populated with ON KEY
    // and ON ACTION commands from 'events'
    var items=[];
    var tailitems= [
			//'->',
			{
				iconCls:"icon-ok",
				text: "OK",
				qtip: "Accept",
				tooltip: "Accept",
				formBind:true,
				handler: function() {
					callback("ACCEPT","ACCEPT");
				}
			},
			{
				iconCls:"icon-cancel",
				text: "Cancel",
				qtip: "Cancel",
				tooltip: "Cancel",
				handler: function() {
					callback("INTERRUPT","INTERRUPT");
				}
			}
		];

	if (context.noTailItemsInToolbar) {
		tailitems=[];
	}


	var a;
	if (events && events.onkey_event && events.onkey_event.length) {
		// 
		// Need to add toolbar items for ON KEY stuff...
		//
		for  (a=0;a<events.onkey_event.length;a++) {
			var evt=events.onkey_event[a];
			evt.context=context;
			evt.callback=callback;
					var itm= {
						iconCls: getIconClassInternal(context.activeApplication, evt.key.trim()),
                                		text: getKeyNameInternal(context.activeApplication, evt.key.trim()),
                                		qtip: getKeyDescriptionInternal(context.activeApplication, evt.key.trim()),
                                		tooltip: getKeyDescriptionInternal(context.activeApplication, evt.key.trim()),
                                		handler: onKeyHandler,
						scope: evt
                                	}
					items.push(itm);
					//break;

		}
	}
	items=items.concat(tailitems);


	// Hide anything with a "hide" for the iconCls..
	var a;
	for(a=0;a<items.length;a++) {
		if (items[a].iconCls=="hide" || items[a].iconCls=="hidden") {
			items[a].hidden=true;
		}
	}

        pan= Ext.create('Ext.toolbar.Toolbar', {
    		A4GL_Context: context,
		originalEvents: events,
        	flex:1,
		items: items,
		layout:menuPosition=="right"?'vbox':'hbox',
//resizable:true,
		//height:90,
		//minWidth:100,

	});

	return pan;
}


